import { ApiPageResponse, ApiParamType, ApiResponse, Pageable } from './types';
export interface TreeApi<Type = any> {
    getTree: (parentId: string | number) => Promise<ApiResponse<Type>>;
    getPickerTree: (parentId: string | number) => Promise<ApiResponse<Type>>;
    getSearch: (data: object, page: Pageable) => Promise<ApiPageResponse<Type>>;
    getOptions?: (data: ApiParamType, page: Pageable) => Promise<ApiPageResponse<Type>>;
}
export declare const defineTreeApi: <Type = any>(path: string) => TreeApi<Type>;
