import { ApiConfig, HttpRequest } from './api';
import { MessageHandler } from './message';
export * from './common';
export * from './auth';
export * from './utils';
export * from './message';
export * from './api';
export interface DinoCoreConfig {
    /**
     * 用于处理消息提示
     *
     * @default nopMessageFun 忽略提示
     */
    message?: MessageHandler;
    /**
     * 用于处理api请求
     *
     * @default 参见 api 模块 {@link setupApi}
     */
    api?: ApiConfig;
    /**
     * 用于执行网络请求的初始化函数
     *
     * @see {@link useAxios}
     */
    requestProvider: (api: ApiConfig) => HttpRequest;
}
export declare const setupDinoCore: (config: DinoCoreConfig) => void;
