"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const axios = require("./axios-miMREx1m.cjs");
require("axios");
require("lodash-es");
require("./index-OTTYrRf9.cjs");
var bind$1 = function bind(fn, thisArg) {
  return function wrap() {
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    return fn.apply(thisArg, args);
  };
};
var bind2 = bind$1;
var toString = Object.prototype.toString;
function isArray(val) {
  return toString.call(val) === "[object Array]";
}
function isUndefined(val) {
  return typeof val === "undefined";
}
function isBuffer(val) {
  return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor) && typeof val.constructor.isBuffer === "function" && val.constructor.isBuffer(val);
}
function isArrayBuffer(val) {
  return toString.call(val) === "[object ArrayBuffer]";
}
function isFormData(val) {
  return typeof FormData !== "undefined" && val instanceof FormData;
}
function isArrayBufferView(val) {
  var result;
  if (typeof ArrayBuffer !== "undefined" && ArrayBuffer.isView) {
    result = ArrayBuffer.isView(val);
  } else {
    result = val && val.buffer && val.buffer instanceof ArrayBuffer;
  }
  return result;
}
function isString(val) {
  return typeof val === "string";
}
function isNumber(val) {
  return typeof val === "number";
}
function isObject(val) {
  return val !== null && typeof val === "object";
}
function isDate(val) {
  return toString.call(val) === "[object Date]";
}
function isFile(val) {
  return toString.call(val) === "[object File]";
}
function isBlob(val) {
  return toString.call(val) === "[object Blob]";
}
function isFunction(val) {
  return toString.call(val) === "[object Function]";
}
function isStream(val) {
  return isObject(val) && isFunction(val.pipe);
}
function isURLSearchParams(val) {
  return typeof URLSearchParams !== "undefined" && val instanceof URLSearchParams;
}
function trim(str) {
  return str.replace(/^\s*/, "").replace(/\s*$/, "");
}
function isStandardBrowserEnv() {
  if (typeof navigator !== "undefined" && (navigator.product === "ReactNative" || navigator.product === "NativeScript" || navigator.product === "NS")) {
    return false;
  }
  return typeof window !== "undefined" && typeof document !== "undefined";
}
function forEach(obj, fn) {
  if (obj === null || typeof obj === "undefined") {
    return;
  }
  if (typeof obj !== "object") {
    obj = [obj];
  }
  if (isArray(obj)) {
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}
function merge() {
  var result = {};
  function assignValue(val, key) {
    if (typeof result[key] === "object" && typeof val === "object") {
      result[key] = merge(result[key], val);
    } else {
      result[key] = val;
    }
  }
  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}
function deepMerge() {
  var result = {};
  function assignValue(val, key) {
    if (typeof result[key] === "object" && typeof val === "object") {
      result[key] = deepMerge(result[key], val);
    } else if (typeof val === "object") {
      result[key] = deepMerge({}, val);
    } else {
      result[key] = val;
    }
  }
  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}
function extend(a, b, thisArg) {
  forEach(b, function assignValue(val, key) {
    if (thisArg && typeof val === "function") {
      a[key] = bind2(val, thisArg);
    } else {
      a[key] = val;
    }
  });
  return a;
}
var utils$1 = {
  isArray,
  isArrayBuffer,
  isBuffer,
  isFormData,
  isArrayBufferView,
  isString,
  isNumber,
  isObject,
  isUndefined,
  isDate,
  isFile,
  isBlob,
  isFunction,
  isStream,
  isURLSearchParams,
  isStandardBrowserEnv,
  forEach,
  merge,
  deepMerge,
  extend,
  trim
};
const utils$2 = /* @__PURE__ */ axios.getDefaultExportFromCjs(utils$1);
var enhanceError$1 = function enhanceError(error, config, code, request, response) {
  error.config = config;
  if (code) {
    error.code = code;
  }
  error.request = request;
  error.response = response;
  error.isAxiosError = true;
  error.toJSON = function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: this.config,
      code: this.code
    };
  };
  return error;
};
var enhanceError2 = enhanceError$1;
var createError$1 = function createError(message, config, code, request, response) {
  var error = new Error(message);
  return enhanceError2(error, config, code, request, response);
};
const createError$2 = /* @__PURE__ */ axios.getDefaultExportFromCjs(createError$1);
var createError2 = createError$1;
var settle = function settle2(resolve, reject, response) {
  var validateStatus = response.config.validateStatus;
  if (!validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(createError2(
      "Request failed with status code " + response.status,
      response.config,
      null,
      response.request,
      response
    ));
  }
};
const settle$1 = /* @__PURE__ */ axios.getDefaultExportFromCjs(settle);
var utils = utils$1;
function encode(val) {
  return encodeURIComponent(val).replace(/%40/gi, "@").replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
var buildURL = function buildURL2(url, params, paramsSerializer) {
  if (!params) {
    return url;
  }
  var serializedParams;
  if (paramsSerializer) {
    serializedParams = paramsSerializer(params);
  } else if (utils.isURLSearchParams(params)) {
    serializedParams = params.toString();
  } else {
    var parts = [];
    utils.forEach(params, function serialize(val, key) {
      if (val === null || typeof val === "undefined") {
        return;
      }
      if (utils.isArray(val)) {
        key = key + "[]";
      } else {
        val = [val];
      }
      utils.forEach(val, function parseValue(v) {
        if (utils.isDate(v)) {
          v = v.toISOString();
        } else if (utils.isObject(v)) {
          v = JSON.stringify(v);
        }
        parts.push(encode(key) + "=" + encode(v));
      });
    });
    serializedParams = parts.join("&");
  }
  if (serializedParams) {
    var hashmarkIndex = url.indexOf("#");
    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }
    url += (url.indexOf("?") === -1 ? "?" : "&") + serializedParams;
  }
  return url;
};
const buildURL$1 = /* @__PURE__ */ axios.getDefaultExportFromCjs(buildURL);
var isAbsoluteURL$1 = function isAbsoluteURL(url) {
  return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
};
var combineURLs$1 = function combineURLs(baseURL, relativeURL) {
  return relativeURL ? baseURL.replace(/\/+$/, "") + "/" + relativeURL.replace(/^\/+/, "") : baseURL;
};
var isAbsoluteURL2 = isAbsoluteURL$1;
var combineURLs2 = combineURLs$1;
var buildFullPath = function buildFullPath2(baseURL, requestedURL) {
  if (baseURL && !isAbsoluteURL2(requestedURL)) {
    return combineURLs2(baseURL, requestedURL);
  }
  return requestedURL;
};
const buildFullPath$1 = /* @__PURE__ */ axios.getDefaultExportFromCjs(buildFullPath);
/*!
 * axios-miniprogram-adapter 0.3.5 (https://github.com/bigMeow/axios-miniprogram-adapter)
 * API https://github.com/bigMeow/axios-miniprogram-adapter/blob/master/doc/api.md
 * Copyright 2018-2022 bigMeow. All Rights Reserved
 * Licensed under MIT (https://github.com/bigMeow/axios-miniprogram-adapter/blob/master/LICENSE)
 */
var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
function encoder(input) {
  var str = String(input);
  var block;
  var charCode;
  var idx = 0;
  var map = chars;
  var output = "";
  for (
    ;
    // if the next str index does not exist:
    //   change the mapping table to "="
    //   check if d has no fractional digits
    str.charAt(idx | 0) || (map = "=", idx % 1);
    // "8 - idx % 1 * 8" generates the sequence 2, 4, 6, 8
    output += map.charAt(63 & block >> 8 - idx % 1 * 8)
  ) {
    charCode = str.charCodeAt(idx += 3 / 4);
    if (charCode > 255) {
      throw new Error("'btoa' failed: The string to be encoded contains characters outside of the Latin1 range.");
    }
    block = block << 8 | charCode;
  }
  return output;
}
var platFormName = "wechat";
function getRequest() {
  switch (true) {
    case typeof wx === "object":
      platFormName = "wechat";
      return wx.request.bind(wx);
    case typeof swan === "object":
      platFormName = "baidu";
      return swan.request.bind(swan);
    case typeof dd === "object":
      platFormName = "dd";
      return dd.httpRequest.bind(dd);
    case typeof my === "object":
      platFormName = "alipay";
      return (my.request || my.httpRequest).bind(my);
    default:
      return wx.request.bind(wx);
  }
}
function transformResponse(mpResponse, config, mpRequestOption) {
  var headers = mpResponse.header || mpResponse.headers;
  var status = mpResponse.statusCode || mpResponse.status;
  var statusText = "";
  if (status === 200) {
    statusText = "OK";
  } else if (status === 400) {
    statusText = "Bad Request";
  }
  var response = {
    data: mpResponse.data,
    status,
    statusText,
    headers,
    config,
    request: mpRequestOption
  };
  return response;
}
function transformError(error, reject, config) {
  switch (platFormName) {
    case "wechat":
      if (error.errMsg.indexOf("request:fail abort") !== -1) {
        reject(createError$2("Request aborted", config, "ECONNABORTED", ""));
      } else if (error.errMsg.indexOf("timeout") !== -1) {
        reject(createError$2("timeout of " + config.timeout + "ms exceeded", config, "ECONNABORTED", ""));
      } else {
        reject(createError$2("Network Error", config, null, ""));
      }
      break;
    case "dd":
    case "alipay":
      if ([14, 19].includes(error.error)) {
        reject(createError$2("Request aborted", config, "ECONNABORTED", "", error));
      } else if ([13].includes(error.error)) {
        reject(createError$2("timeout of " + config.timeout + "ms exceeded", config, "ECONNABORTED", "", error));
      } else {
        reject(createError$2("Network Error", config, null, "", error));
      }
      break;
    case "baidu":
      reject(createError$2("Network Error", config, null, ""));
      break;
  }
}
function transformConfig(config) {
  var _a;
  if ([
    "alipay",
    "dd"
    /* 钉钉 */
  ].includes(platFormName)) {
    config.headers = config.header;
    delete config.header;
    if ("dd" === platFormName && config.method !== "GET" && ((_a = config.headers) === null || _a === void 0 ? void 0 : _a["Content-Type"]) === "application/json" && Object.prototype.toString.call(config.data) === "[object Object]") {
      config.data = JSON.stringify(config.data);
    }
  }
  return config;
}
var isJSONstr = function(str) {
  try {
    return typeof str === "string" && str.length && (str = JSON.parse(str)) && Object.prototype.toString.call(str) === "[object Object]";
  } catch (error) {
    return false;
  }
};
function mpAdapter(config, _a) {
  var _b = (_a === void 0 ? {} : _a).transformRequestOption, transformRequestOption = _b === void 0 ? function(requestOption) {
    return requestOption;
  } : _b;
  var request = getRequest();
  return new Promise(function(resolve, reject) {
    var requestTask;
    var requestData = config.data;
    var requestHeaders = config.headers;
    var requestMethod = config.method && config.method.toUpperCase() || "GET";
    var mpRequestOption = {
      method: requestMethod,
      url: buildURL$1(buildFullPath$1(config.baseURL, config.url), config.params, config.paramsSerializer),
      timeout: config.timeout,
      // Listen for success
      success: function(mpResponse) {
        var response = transformResponse(mpResponse, config, mpRequestOption);
        settle$1(resolve, reject, response);
      },
      // Handle request Exception
      fail: function(error) {
        transformError(error, reject, config);
      },
      complete: function() {
        requestTask = void 0;
      }
    };
    if (config.auth) {
      var _a2 = [config.auth.username || "", config.auth.password || ""], username = _a2[0], password = _a2[1];
      requestHeaders.Authorization = "Basic " + encoder(username + ":" + password);
    }
    utils$2.forEach(requestHeaders, function setRequestHeader(val, key) {
      var _header = key.toLowerCase();
      if (typeof requestData === "undefined" && _header === "content-type" || _header === "referer") {
        delete requestHeaders[key];
      }
    });
    mpRequestOption.header = requestHeaders;
    if (config.responseType) {
      mpRequestOption.responseType = config.responseType;
    }
    if (config.cancelToken) {
      config.cancelToken.promise.then(function onCanceled(cancel) {
        if (!requestTask) {
          return;
        }
        requestTask.abort();
        reject(cancel);
        requestTask = void 0;
      });
    }
    if (isJSONstr(requestData)) {
      requestData = JSON.parse(requestData);
    }
    if (requestData !== void 0) {
      mpRequestOption.data = requestData;
    }
    requestTask = request(transformRequestOption(transformConfig(mpRequestOption)));
  });
}
const wxRequestProvider = axios.axiosWithAdapter(mpAdapter);
exports.wxRequestProvider = wxRequestProvider;
